# -*- coding: utf-8 -*-

import xbmc
import xbmcgui, xbmcvfs
import os
import shutil

from resources.lib.clean import openn
from resources.lib.clean import addon
from resources.lib.modules import control


def clean_menu():
    openn.addDir('[B][COLOR white]Clean Data[/COLOR][/B]', '', 556, 'https://i.imgur.com/2cPUPkf.png', addon.art, 'clean')
    openn.addDir('[B][COLOR white]Package Delete[/COLOR][/B]', '', 555, 'https://i.imgur.com/2cPUPkf.png', addon.art, 'pakage delete')
    openn.addDir('[B][COLOR white]benchmark[/COLOR][/B]', 'plugin://script.pystone.benchmark', 560, 'https://i.imgur.com/2cPUPkf.png', addon.art, 'speedtest')
    openn.addDir('[B][COLOR blue]installer GKN[/COLOR][/B]', '', 561, 'https://i.imgur.com/2cPUPkf.png', addon.art, 'Gkn')
    openn.addDir('[B][COLOR blue]installer GRecoTM[/COLOR][/B]', '', 561, 'https://i.imgur.com/2cPUPkf.png', addon.art, 'GrecoTM')


def vodil(url):

    ok = True
    xbmc.executebuiltin('XBMC.Container.Update(%s)' % url)
    return clean_menu()


def Installxe(typos):
    if typos == 'greco':
        control.infoDialog('GRecoTM repository installed', control.addonInfo('name'), '', 6000)
        greco_path = xbmc.translatePath(os.path.join('special://home/addons', 'repository.GRecoTM'))
        grecoxml = xbmc.translatePath(os.path.join('special://home/addons', 'repository.GRecoTM', 'addon.xml'))

        if not xbmcvfs.exists(greco_path):
            xbmcvfs.mkdir(greco_path)

        try:
            with open(grecoxml) as r:
                xml = r.read()
        except IOError:
            xml = ''

        if 'repository.GRecoTM' not in xml:
            repo = '''<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
                        <addon id="repository.GRecoTM" name=" GRecoTM Repository" version="2.3" provider-name="GRecoTM">
                            <extension point="xbmc.addon.repository" name="GRecoTM Repository">
                                <info compressed="false">http://grrepo.grecotm.com/Plugins/addons.xml</info>
                                <checksum>http://grrepo.grecotm.com/Plugins/addons.xml.md5</checksum>
                                <datadir zip="true">http://grrepo.grecotm.com/Plugins/</datadir>
                                <dir>
                                    <info compressed="false">https://raw.githubusercontent.com/jsergio123/zips/master/addons.xml</info>
                                    <checksum>https://raw.githubusercontent.com/jsergio123/zips/master/addons.xml.md5</checksum>
                                    <datadir zip="true">https://raw.githubusercontent.com/jsergio123/zips/master/</datadir>
                                </dir>
                            </extension>
                            <extension point="xbmc.addon.metadata">
                                <summary>GRecoTM Repository</summary>
                                <description>All you need for a GREEK KODI-ΟΤΙ χρειάζεσαι για ένα Ελληνικό KODI</description>
                                <platform>all</platform>
                            </extension>
                        </addon>'''

            with open(grecoxml, mode='w') as f:
                f.write(repo)

            xbmc.executebuiltin('UpdateLocalAddons')

            from xbmc import sleep
            sleep(2000)

            query = '{"jsonrpc":"2.0","method":"Addons.SetAddonEnabled","params":{"addonid":"repository.GRecoTM","enabled":true},"id":1}'
            xbmc.executeJSONRPC(query)

            xbmc.executebuiltin("UpdateAddonRepos")

    else:
        control.infoDialog('GKNwizard repository installed', control.addonInfo('name'), '', 6000)
        gkn_path = xbmc.translatePath(os.path.join('special://home/addons', 'repository.gknwiz'))
        gknxml = xbmc.translatePath(os.path.join('special://home/addons', 'repository.gknwiz', 'addon.xml'))

        if not xbmcvfs.exists(gkn_path):
            xbmcvfs.mkdir(gkn_path)

        try:
            with open(gknxml) as r:
                xml = r.read()
        except IOError:
            xml = ''

        if 'repository.gknwiz' not in xml:
            repo = '''<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
                        <addon id="repository.gknwiz" name="GKNwizard Repo" version="0.0.1" provider-name="GKN">
                            <extension point="xbmc.addon.repository" name="GKNwizard Repo">
                                <info compressed="false">http://gknwizard.eu/repo/wizard/addons.xml</info>
                                <checksum>http://gknwizard.eu/repo/wizard/addons.xml.md5</checksum>
                                <datadir zip="true">http://gknwizard.eu/repo/wizard/</datadir>
                            </extension>	
                            <extension point="xbmc.addon.metadata">
                                <summary>GKN Repository</summary>
                                <description>Greek kodi network repository</description>
                                <platform>all</platform>
                            </extension>
                        </addon>'''

            with open(gknxml, mode='w') as f:
                f.write(repo)

            xbmc.executebuiltin('UpdateLocalAddons')

            from xbmc import sleep
            sleep(2000)

            query = '{"jsonrpc":"2.0","method":"Addons.SetAddonEnabled","params":{"addonid":"repository.gknwiz","enabled":true},"id":1}'
            xbmc.executeJSONRPC(query)

            xbmc.executebuiltin("UpdateAddonRepos")


################################################################################################################################


def auto_clean(url):
    print '############################################################       DELETING STANDARD CACHE             ###############################################################'
    xbmc_cache_path = os.path.join(xbmc.translatePath('special://home'), 'cache')
    if os.path.exists(xbmc_cache_path) == True:
        for root, dirs, files in os.walk(xbmc_cache_path):
            file_count = 0
            file_count += len(files)

        # Count files and give option to delete
            if file_count > 0:

                dialog = xbmcgui.Dialog()
                if dialog.yesno("Διαγράψτε τα προσωρινά αρχεία", str(file_count) + "Βρέθηκαν αρχεία", "Διαγραφή των αρχείων;"):

                    for f in files:
                        try:
                            os.unlink(os.path.join(root, f))
                        except:
                            pass
                    for d in dirs:
                        try:
                            shutil.rmtree(os.path.join(root, d))
                        except:
                            pass

            else:
                pass
    if xbmc.getCondVisibility('system.platform.ATV2'):
        atv2_cache_a = os.path.join('/private/var/mobile/Library/Caches/AppleTV/Video/', 'Other')

        for root, dirs, files in os.walk(atv2_cache_a):
            file_count = 0
            file_count += len(files)

            if file_count > 0:

                dialog = xbmcgui.Dialog()
                if dialog.yesno("Delete ATV2 Cache Files", str(file_count) + " files found in 'Other'", "Do you want to delete them?"):

                    for f in files:
                        os.unlink(os.path.join(root, f))
                    for d in dirs:
                        shutil.rmtree(os.path.join(root, d))

            else:
                pass
        atv2_cache_b = os.path.join('/private/var/mobile/Library/Caches/AppleTV/Video/', 'LocalAndRental')

        for root, dirs, files in os.walk(atv2_cache_b):
            file_count = 0
            file_count += len(files)

            if file_count > 0:

                dialog = xbmcgui.Dialog()
                if dialog.yesno("Delete ATV2 Cache Files", str(file_count) + " files found in 'LocalAndRental'", "Do you want to delete them?"):

                    for f in files:
                        os.unlink(os.path.join(root, f))
                    for d in dirs:
                        shutil.rmtree(os.path.join(root, d))

            else:
                pass

                # Set path to Simple Downloader cache files
    downloader_cache_path = os.path.join(xbmc.translatePath('special://profile/addon_data/script.module.simple.downloader'), '')
    if os.path.exists(downloader_cache_path) == True:
        for root, dirs, files in os.walk(downloader_cache_path):
            file_count = 0
            file_count += len(files)

        # Count files and give option to delete
            if file_count > 0:

                dialog = xbmcgui.Dialog()
                if dialog.yesno("Delete Simple Downloader Cache Files", str(file_count) + " files found", "Do you want to delete them?"):

                    for f in files:
                        os.unlink(os.path.join(root, f))
                    for d in dirs:
                        shutil.rmtree(os.path.join(root, d))

            else:
                pass

                # Set path to temp cache files
    temp_cache_path = os.path.join(xbmc.translatePath('special://home/temp'), '')
    if os.path.exists(temp_cache_path) == True:
        for root, dirs, files in os.walk(temp_cache_path):
            file_count = 0
            file_count += len(files)

        # Count files and give option to delete
            if file_count > 0:

                dialog = xbmcgui.Dialog()
                if dialog.yesno("Delete TEMP dir Cache Files", str(file_count) + " files found", "Do you want to delete them?"):

                    for f in files:
                        os.unlink(os.path.join(root, f))
                    for d in dirs:
                        shutil.rmtree(os.path.join(root, d))

            else:
                pass

    dialog = xbmcgui.Dialog()
    dialog.ok("ATLAS tools", "Όλα τα προσωρινά αρχεία έχουν καταργηθεί", "ATLAS tools")


#############################################################################################################################################
def katell():
    purgePath = xbmc.translatePath('special://home/addons/packages')
    dialog = xbmcgui.Dialog()
    for root, dirs, files in os.walk(purgePath):
        file_count = 0
        file_count += len(files)
    if dialog.yesno("Package Διαγραφή", "%d Βρέθηκαν." % file_count, "Θέλετε να τα Διαγράψετε;"):
        for root, dirs, files in os.walk(purgePath):
            file_count = 0
            file_count += len(files)
            if file_count > 0:
                for f in files:
                    os.unlink(os.path.join(root, f))
                for d in dirs:
                    shutil.rmtree(os.path.join(root, d))
                dialog = xbmcgui.Dialog()
                dialog.ok("ATLAS tools", "Διαγραφή επιτυχές")
            else:
                dialog = xbmcgui.Dialog()
                dialog.ok("ATLAS tools", "Packages Δεν βρέθηκαν")


############################################################################################################################################
